#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_RedPackagelotteryCFG.h"
std::auto_ptr<Fish_RedPackagelotteryCFG> Fish_RedPackagelotteryCFG::msSingleton(nullptr);

int Fish_RedPackagelotteryCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_RedPackagelotteryCFGData* Fish_RedPackagelotteryCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_RedPackagelotteryCFGData>& Fish_RedPackagelotteryCFG::GetMapData()
{
	return mMapData;
}

void Fish_RedPackagelotteryCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_RedPackagelotteryCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_RedPackagelotteryCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mRedPageItem = element->IntAttribute("RedPageItem");
		data.mRedPageQuantity = element->IntAttribute("RedPageQuantity");
		data.mWeight = element->IntAttribute("Weight");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_RedPackagelotteryCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_RedPackagelotteryCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_RedPackagelotteryCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_RedPackagelotteryCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_RedPackagelotteryCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "RedPageItem", data.mRedPageItem);
		LuaCfgHelper::readInt(L, "RedPageQuantity", data.mRedPageQuantity);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_RedPackagelotteryCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_RedPackagelotteryCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_RedPackagelotteryCFG* Fish_RedPackagelotteryCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_RedPackagelotteryCFG());
	}
	return msSingleton.get();
}

void Fish_RedPackagelotteryCFG::Release()
{
	msSingleton.reset(nullptr);
}
